VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   1740
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4665
   LinkTopic       =   "Form1"
   ScaleHeight     =   1740
   ScaleWidth      =   4665
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtSearch 
      Height          =   315
      Left            =   1740
      TabIndex        =   2
      Text            =   "control"
      Top             =   1260
      Width           =   1215
   End
   Begin VB.TextBox Text1 
      Height          =   1035
      Left            =   60
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   1
      Top             =   120
      Width           =   4395
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Make Underline"
      Height          =   375
      Left            =   3060
      TabIndex        =   0
      Top             =   1260
      Width           =   1455
   End
   Begin VB.Label Label1 
      Caption         =   "Word to underline:"
      Height          =   315
      Left            =   60
      TabIndex        =   3
      Top             =   1260
      Width           =   1455
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Copyright  2002 Steve Sykes
'Steve@ISISDev.com

'Many times I have wondered how applications underline misspelled words
'I finally took the time to write some routines to make it possible for myself.

'This should provide a good jump start for who ever wants to do the same.
'I personally don't like to use 3rd party controls because of
'the lack of instant support when something doesn't work right.

'This code may be used in compiled form in any way you desire. This
'project may be redistributed unmodified by any means PROVIDING it is
'not sold for profit without the authors written consent, and
'providing that this notice and the authors name and all copyright
'notices remains intact. If the source code in this file is used in
'any commercial application then a statement along the lines of
'"Portions Copyright  2002 Steve Sykes" must be included in
'the startup banner, "About" box or printed documentation. An email
'letting me know that you are using it would be nice as well. That's
'not much to ask considering the amount of work that went into this.
'
'This file is provided "as is" with no expressed or implied warranty.
'The author accepts no liability for any damage/loss of business that
'this product may cause.


Option Explicit
Const PS_DOT = 2
Const PS_SOLID = 0

Private Type TSIZE
    cx_width As Long
    cy_height As Long
End Type

Private Type POINTAPI
    X As Long
    Y As Long
End Type

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Const EM_POSFROMCHAR As Long = &HD6

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" ( _
                         ByVal hWnd As Long, _
                         ByVal wMsg As Long, _
                         ByVal wParam As Long, _
                         lParam As Any _
                         ) As Long

Private Declare Function GetTextExtentPoint32 Lib "gdi32" Alias "GetTextExtentPoint32A" ( _
                        ByVal hdc As Long, _
                        ByVal lpsz As String, _
                        ByVal cbString As Long, _
                        lpSize As TSIZE) As Long
                        
Private Declare Function GetWindowRect Lib "user32" ( _
                        ByVal hWnd As Long, _
                        lpRect As RECT) As Long

Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" ( _
                        ByVal hWnd As Long, _
                        ByVal lpString As String, _
                        ByVal cch As Long) As Long
                        
Private Declare Function GetWindowTextLength Lib "user32" Alias "GetWindowTextLengthA" ( _
                        ByVal hWnd As Long) As Long

Private Declare Function GetDC Lib "user32" ( _
                        ByVal hWnd As Long) As Long
                        
Private Declare Function DeleteObject Lib "gdi32" ( _
                        ByVal hObject As Long) As Long
                        
Private Declare Function SelectObject Lib "gdi32" ( _
                        ByVal hdc As Long, _
                        ByVal hObject As Long) As Long
                        
Private Declare Function CreatePen Lib "gdi32" ( _
                        ByVal nPenStyle As Long, _
                        ByVal nWidth As Long, _
                        ByVal crColor As Long) As Long
                        
Private Declare Function PolylineTo Lib "gdi32" ( _
                        ByVal hdc As Long, _
                        lppt As POINTAPI, _
                        ByVal cCount As Long) As Long
                        
Private Declare Function MoveToEx Lib "gdi32" ( _
                        ByVal hdc As Long, _
                        ByVal X As Long, _
                        ByVal Y As Long, _
                        ByVal lpPoint As Any) As Long

Public Sub MakeUnderLine(m_hWndEditControl As Long, _
                        StrToUnderLine As String, _
                        mColor As ColorConstants)
    Dim Pt(0 To 255) As POINTAPI
    Dim Number As Integer
    Dim hRPen As Long
    Dim m_hDc As Long
    Dim m_width As Long
    Dim TextSize As TSIZE
    Dim rc As RECT
    Dim Ypos As Long
    Dim TextLength As Long
    Dim TextStr As String
    Dim m_X As Long
    Dim m_Y As Long
    Dim Mark As Long
    Dim OffSet As Long

    hRPen = CreatePen(PS_SOLID, 1, mColor)
    m_hDc = GetDC(m_hWndEditControl)
    GetWindowRect m_hWndEditControl, rc

    TextStr = Space(GetWindowTextLength(m_hWndEditControl))
    'Get the window's text
    GetWindowText m_hWndEditControl, TextStr, Len(TextStr) + 1
    Mark = InStr(1, TextStr, StrToUnderLine, vbTextCompare)
    If Mark > 0 Then
        CharPosFromIndex m_hWndEditControl, Mark - 1, m_X, m_Y
        '14 is a good offset for now.
        'To do: get metrics on max char height and add 1 or 2
        'for proper offset
        m_Y = m_Y + 12 '12 is an offset
        Ypos = m_Y
        OffSet = m_X
    Else
        GoTo Failed
    End If
    
    GetTextExtentPoint32 m_hDc, StrToUnderLine, Len(StrToUnderLine), TextSize

    'Select our pen into the objects device context
    SelectObject m_hDc, hRPen
   
    m_width = (TextSize.cx_width / 4.1) + 1
    
    For Number = 0 To CInt(m_width)
        If Number Mod 2 = 0 Then
            Pt(Number).X = (Number * 3) + OffSet
            Pt(Number).Y = Ypos
        Else
            Pt(Number).X = (Number * 3) + OffSet
            Pt(Number).Y = Ypos + 5
        End If
    Next Number
    
    MoveToEx m_hDc, OffSet, Ypos, ByVal 0&
    'Set the cordinates of the active point
    PolylineTo m_hDc, Pt(0), m_width
    DeleteObject hRPen
   
Failed:

End Sub

Private Sub CharPosFromIndex( _
                            m_hWndEditControl As Long, _
                            Pos As Long, _
                            X As Long, _
                            Y As Long)
    Dim mWord As Long
    mWord = SendMessage(m_hWndEditControl, EM_POSFROMCHAR, Pos, 0&)
    X = LoWord(mWord)
    Y = HiWord(mWord)
End Sub

Private Sub Form_Load()
    Text1.Text = "If the function succeeds, the application " & _
                 "can access the contents of the edit control by casting the return"
End Sub

Function HiWord(dw As Long) As Integer
   If dw And &H80000000 Then
       HiWord = (dw \ 65535) - 1
   Else
       HiWord = dw \ 65535
   End If
End Function

Function LoWord(dw As Long) As Integer
   If dw And &H8000& Then
       LoWord = &H8000 Or (dw And &H7FFF&)
   Else
       LoWord = dw And &HFFFF&
   End If
End Function

Private Sub Command1_Click()
    Static WhiteOn As Boolean
    If Not WhiteOn Then
        MakeUnderLine Text1.hWnd, txtSearch.Text, vbRed
    Else
        MakeUnderLine Text1.hWnd, txtSearch.Text, vbWhite
    End If
    WhiteOn = Not (WhiteOn)
End Sub

